<template>
  <div class="container">
    <logo class="logo" :showText="false" />
    <p v-if="redirect">necesitas iniciar sesión para ir acá.</p>
    <custom-form
      :fields="fields"
      :handleSubmit="handleSubmit"
      :parseError="parseError"
    />
    <small>
      <router-link :to="crearCuentaPath">¿no tenés una cuenta?</router-link>
    </small>
  </div>
</template>

<script>
import CustomForm from '@/components/Form'
import Logo from '@/components/Logo'

export default {
  name: 'IniciarSesionView',
  data() {
    return {
      fields: [
        {
          name: 'email',
          placeholder: 'Dirección de e-mail',
          required: true,
          type: 'email',
        },
        {
          name: 'password',
          placeholder: 'Contraseña',
          required: true,
          minLength: 8,
          type: 'password',
        },
        { type: 'submit', content: 'Iniciar sesión' },
      ],
    }
  },
  components: {
    Logo,
    CustomForm,
  },
  computed: {
    redirect() {
      return this.$route.query.redirect
    },
    crearCuentaPath() {
      return `/crearCuenta${
        this.redirect ? '?redirect=' + encodeURIComponent(this.redirect) : ''
      }`
    },
  },
  methods: {
    handleSubmit(userData) {
      return this.$store
        .dispatch('logIn', userData)
        .then(res => this.$router.replace(this.redirect || '/'))
    },
    parseError: error => {
      if (error === 'forbidden') return 'E-mail o contraseña incorrecta.'
      else return error
    },
  },
}
</script>

<style scoped>
.logo {
  padding: 10% 35%;
}
</style>
